<?php
/**
 * @version 1.0 $Id: autorelationfilters.php
 * @package Joomla
 * @subpackage FLEXIcontent
 * @subpackage plugin.autorelationfilters
 * @copyright (C) 2011 ggppdk
 * @license GNU/GPL v2
 *
 * FLEXIcontent is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 */
defined( '_JEXEC' ) or die( 'Restricted access' );

jimport('joomla.event.plugin');

class plgFlexicontent_fieldsAutorelationfilters extends JPlugin
{
	// ***********
	// CONSTRUCTOR
	// ***********
	static $field_types = array('autorelationfilters');
	
	function plgFlexicontent_fieldsAutorelationfilters( &$subject, $params )
	{
		parent::__construct( $subject, $params );
		JPlugin::loadLanguage('plg_flexicontent_fields_autorelationfilters', JPATH_ADMINISTRATOR);
	}
	
	
	
	// *******************************************
	// DISPLAY methods, item form & frontend views
	// *******************************************
	
	// Method to create field's HTML display for item form
	function onDisplayField(&$field, &$item)
	{
		if ( !in_array($field->field_type, self::$field_types) ) return;
		$field->label = JText::_($field->label);
		
		// Get some api objects
		$db   = JFactory::getDBO();
		$user = JFactory::getUser();
		$document = JFactory::getDocument();
		
		//print_r($field->value); exit;
		if ( !empty($field->value[0]) ) {
			$values = @ unserialize($field->value[0]);
			if ( $values!== false ) {
				foreach($values as $filt_name => $filt_vals) {
					// Skip filters without value
					$empty_filt_vals_array  = is_array($filt_vals)  && !strlen(trim(implode('',$filt_vals)));
					$empty_filt_vals_string = !is_array($filt_vals) && !strlen(trim($filt_vals));
					if ( $empty_filt_vals_array || $empty_filt_vals_string ) continue;
					JRequest::setVar('iform_'.$filt_name, $filt_vals);
				}
			}
		}
		
		$field->parameters->set('use_filters', 1);
		$filters = FlexicontentFields::getFilters('filters', 'use_filters', $field->parameters, $check_access=false);
		if ($field->parameters->get( 'display_cat_list', 0 )) {
			unset($filters['categories']);
		}
		if ($field->parameters->get('use_static_filters')) FlexicontentFields::setFilterValues( $field->parameters, 'static_filters', $is_persistent=1, $set_method="array");
		FlexicontentFields::setFilterValues( $field->parameters, 'initial_filters', $is_persistent=0);
		if ( !empty($filters) ) {
			FlexicontentFields::renderFilters( $field->parameters, $filters, $form_name='item_form' );
		}
		
		// Prefix/Suffix texts
		$pretext = $field->parameters->get( 'filter_pretext', '' );
		$posttext = $field->parameters->get( 'filter_posttext', '' );
		
		// Open/Close tags
		$opentag = $field->parameters->get( 'filter_opentag', '' );
		$closetag = $field->parameters->get( 'filter_closetag', '' );
		
		$filter_placement = $field->parameters->get( 'filter_placement', 0 );
		$show_filter_labels = $field->parameters->get('show_filter_labels', 1);
		
		$filter_container_class  = $filter_placement ? 'fc_filter_line' : 'fc_filter';
		$filter_container_class .= $filter_placement==2 ? ' fc_clear_label' : '';
		
		
		// The category selector
		if ($field->parameters->get( 'display_cat_list', 0 )) {
			$allowedtree = $this->decideCats($field->parameters);
			$mcats_selection = $field->parameters->get( 'mcats_selection', 1 );  // TODO use this ?
			
			$_fld_name = 'filter_13';
			$_fld_attributes = ' class="fc_field_filter use_select2_lib" ';
			if ($mcats_selection) {
				$_fld_attributes .= ' multiple="multiple" ';
				$_fld_name .= '[]';
			}
			
			$selected_cats = JRequest::getVar('iform_filter_13', '', 'default');
			$top = false;
			
			$field->parameters->set( 'cats_filter', array(13));
			$cats_filter = FlexicontentFields::getFilters('cats_filter', 'use_filters', $field->parameters, $check_access=false);
			$cats_filter['categories']->html = flexicontent_cats::buildcatselect($allowedtree, $_fld_name, $selected_cats, $top, $_fld_attributes, $check_published = true, $check_perms = false, array(), $require_all=false);
			array_push($filters, $cats_filter['categories']);
		}
		
		
		$filters_html = array();
		$n = 0;
		foreach ($filters as $filt) :
			if (empty($filt->html)) continue;
			
			// Support for old 3rd party filters, that include an auto-submit statement or include a fixed form name
			// These CUSTOM fields should be updated to have this auto-submit code removed fixed form name changed too
			
			// Compatibility HACK 1
			// These fields need to be have their onChange Event prepended with the FORM PREPARATION function call,
			// ... but if these filters change value after we 'prepare' form then we have an issue ...
			if ( preg_match('/onchange[ ]*=[ ]*([\'"])/i', $filt->html, $matches) && preg_match('/\.submit\(\)/', $filt->html, $matches) ) {
				$filt->html = preg_replace('/onchange[ ]*=[ ]*([\'"])/i', 'onchange=${1}'.$prepend_onchange, $filt->html);
			}
			
			// Compatibility HACK 2
			// These fields also need to have any 'adminForm' string present in their filter's HTML replaced with the name of our form
			$filter_html[$filt->id] = preg_replace('/([\'"])adminForm([\'"])/', '${1}'.$form_name.'${2}', $filt->html);
			
			$_filter_html  = $pretext;
			$_filter_html .= '<span class="'.$filter_container_class.(($n++)%2 ? ' fc_even': ' fc_odd').' fc_filter_id_'.$filt->id.'" >' ."\n";
			$_filter_html .= ($show_filter_labels==1 || ($show_filter_labels==0 && $filt->parameters->get('display_label_filter')==1))
				? ' <span class="fc_filter_label fc_label_field_'.$filt->id.'">' .$filt->label. '</span>' ."\n"  :  '';
			$_filter_html .= ' <span class="fc_filter_html fc_html_field_'.$filt->id.'">' .$filt->html. '</span>' ."\n";
			$_filter_html .= '</span>'."\n";
			$_filter_html .= $posttext;
			$filters_html[] = $_filter_html;
		endforeach;
		
		$separatorf = '';
		$filter_placement=0;
		if ( $filter_placement==0 ) {  
			$separatorf = $field->parameters->get( 'filter_separatorf', 1 );
			$separators_arr = array( 0 => '&nbsp;', 1 => '<br />', 2 => '&nbsp;|&nbsp;', 3 => ',&nbsp;', 4 => $closetag.$opentag, 5 => '' );
			$separatorf = isset($separators_arr[$separatorf]) ? $separators_arr[$separatorf] : '&nbsp;';
		}
		
		$field->html = $opentag . implode($separatorf, $filters_html) . $closetag;
		unset ($filters_html);
		
		flexicontent_html::loadFramework('flexi_tmpl_common');
		$document->addStyleSheet(JURI::root(true).'/components/com_flexicontent/assets/css/flexi_frontend.css');
	}
	
	
	// Method to create field's HTML display for frontend views
	function onDisplayFieldValue(&$field, $item, $values=null, $prop='display')
	{
		if ( !in_array($field->field_type, self::$field_types) ) return;
		
		$field->label = JText::_($field->label);
		$field->{$prop} = '';
		$values = $values ? $values : $field->value;
		
		$db = JFactory::getDBO();
		$view = JRequest::getVar('view');
		
		
		// *******************************************
		// Get configuration of fields used as filters
		// *******************************************
		
		require_once (JPATH_SITE.DS.'components'.DS.'com_flexicontent'.DS.'models'.DS.'category.php');
		
		$_cid_saved = JRequest::getVar('cid');
		JRequest::setVar('cid', 0);
		$catmodel = new FlexicontentModelCategory();
		JRequest::setVar('cid', $_cid_saved);
		
		$field->parameters->set('use_filters', 1);
		$shown_filters  = FlexicontentFields::getFilters('filters', 'use_filters', $field->parameters, $check_access=false);
		$static_filters = FlexicontentFields::getFilters('static_filters', 'use_static_filters', $field->parameters, $check_access=false );
		if ($field->parameters->get('use_static_filters')) {
			$static_filter_vals = FlexicontentFields::setFilterValues( $field->parameters, 'static_filters', $is_persistent=1, $set_method="array");
		} else {
			$static_filter_vals = array();
		}
		
		
		// ****************************************
		// Merge shown and locked (static) filters
		// ****************************************
		
		$filters = array();
		if ($shown_filters)  foreach ($shown_filters  as $filt_name => $filt) $filters[$filt->id] = $filt;
		if ($static_filters) foreach ($static_filters as $filt_name => $filt) $filters[$filt->id] = $filt;
		
		
		// *****************
		// Get filter values
		// *****************
		
		// Get filter values that were shown & set via item FORM
		$values = empty($field->value[0])  ?  false  :  @ unserialize($field->value[0]);
		if ( empty($values) ) $values = array();
		
		// Get filter values that were statically set via field's configuration
		foreach($static_filter_vals as $filt_id => $filt_vals) $values['filter_'.$filt_id] = $filt_vals;
		
		
		// ******************
		// Get SQL of filters
		// ******************
		
		$filters_query = array();
		foreach($values as $filt_name => $filt_vals) {
			$filt_id = str_replace('filter_', '', $filt_name);
			
			// Skip filters without value or missing filters
			$empty_filt_vals_array  = is_array($filt_vals)  && !strlen(trim(implode('',$filt_vals)));
			$empty_filt_vals_string = !is_array($filt_vals) && !strlen(trim($filt_vals));
			
			if ( $empty_filt_vals_array || $empty_filt_vals_string ) continue;
			if ( !isset($filters[$filt_id]) )  continue;
			
			//echo $filters[$filt_id]->name . "[".$filt_id."]: ";
			//echo $filt_id.": "; print_r($filt_vals);
			$filters_query[$filt_id] = $catmodel->_getFiltered($filters[$filt_id], $filt_vals);
			//echo "<br/>".$filters_query[$filt_id] . "<br/><br/>\n";
		}
		
		
		// ********************************
		// Execute SQL to get list of items
		// ********************************
		
		if ($view=='category') {
			$query = "SELECT COUNT(*) FROM #__flexicontent_items_tmp AS i WHERE 1=1 ". implode(' ',$filters_query);
			$db->setQuery($query);
			$count_items = $db->loadResult();
		} else {
			$list_limit = $field->parameters->get('list_limit', 50);
			$query = "SELECT i.id, i.catid FROM #__flexicontent_items_tmp AS i WHERE 1=1 ". implode(' ',$filters_query);
			$db->setQuery($query, 0, $list_limit);
			$_itemids_catids = $db->loadObjectList('id');
		}
		//print_r($_itemids_catids);
		//exit;
		
		
		// *****************************
		// Finally, create the item list
		// *****************************
		
		if ($view=='category') {
			$field->{$prop} .= $count_items . ' '. JText::_('items');
		} else {
			$field->{$prop} .= 'Found '.count($_itemids_catids).' items:<br>';
			$field->{$prop} .= !count($_itemids_catids) ? '' :
				FlexicontentFields::getItemsList($field->parameters, $_itemids_catids, $isform=0, @ $reverse_field, $field, $item);
		}
	}
	
	
	
	// **************************************************************
	// METHODS HANDLING before & after saving / deleting field events
	// **************************************************************
	
	// Method to handle field's values before they are saved into the DB
	function onBeforeSaveField( &$field, &$post, &$file, &$item )
	{
		if ( !in_array($field->field_type, self::$field_types) ) return;
		if(!is_array($post) && !strlen($post)) return;
		
		$field->parameters->set('use_filters', 1);
		$filters = FlexicontentFields::getFilters('filters', 'use_filters', $field->parameters, $check_access=false);
		
		foreach ($filters as $filt_name => $filt) {
			//echo $filt_name ."[". $filt->id ."] : ";
			$filt_vals['filter_'.$filt->id] = JRequest::getVar('filter_'.$filt->id);
			//print_r($filt_vals['filter_'.$filt->id]);
			//echo "<br/>\n";
		}
		//echo "<br/><br/>\n";
		//print_r($filt_vals);
		$post = array($filt_vals);
	}
	
	
	// Method to take any actions/cleanups needed after field's values are saved into the DB
	function onAfterSaveField( &$field, &$post, &$file, &$item ) {
	}
	
	
	// Method called just before the item is deleted to remove custom item data related to the field
	function onBeforeDeleteField(&$field, &$item) {
	}


	public static function decideCats( &$params )
	{
		global $globalcats;
		
		$display_cat_list = $params->get('display_cat_list', 0);
		$catids = $params->get('catids', array());
		$usesubcats = $params->get('usesubcats', 0 );
		
		// FIND categories to display
		$allowed_cats = $disallowed_cats = false;
		
		if ($usesubcats) {
			// Find descendants of the categories
			$subcats = array();
			foreach ($catids as $catid) {
				$subcats = array_merge($subcats, array_map('trim',explode(",",$globalcats[$catid]->descendants)) );
			}
			$catids = array_unique($subcats);
		}
		
    if ( $display_cat_list == 1 ) {  // include method
    	$allowed_cats = $catids;
    } else if ( $display_cat_list == 2 ) {  // exclude method
    	$disallowed_cats = $catids;
    }
    
		$tree = flexicontent_cats::getCategoriesTree();
		if ($allowed_cats) {
			foreach ($allowed_cats as $catid) {
				$allowedtree[$catid] = $tree[$catid];
			}
		}
		if ($disallowed_cats) {
			foreach ($disallowed_cats as $catid) {
				unset($tree[$catid]);
			}
			$allowedtree = & $tree;
		}
		if (!$allowed_cats && !$disallowed_cats) {
			$allowedtree = & $tree;
		}
		
		return $allowedtree;
	}


}
